## gemmlowp 0.0~git20211220.e844ffd

=== contrib/CMakeLists.txt ===
# Gemmlowp CMake file written for Debian.
# Copyright © 2016 Zhou Mo <cdluminate@gmail.com>
# Licence Apache-2.0

cmake_minimum_required(VERSION 3.7)

# Project
project(gemmlowp C CXX)

include(CTest) # option(BUILD_TESTING). ON by default.
include(GNUInstallDirs)

# Set C++11 as default standard
set(CMAKE_CXX_STANDARD 11)

get_filename_component(gemmlowp_src ${gemmlowp_SOURCE_DIR} PATH)

if(WIN32)
  # one can enable simd from the cmake command line, ie -DCMAKE_CXX_FLAGS="/arch:AVX2
  add_definitions(-DNOMINMAX -DWIN64 -DWIN32_LEAN_AND_MEAN -DNOGDI)
  add_definitions(/bigobj /nologo /EHsc /GF /MP /Gm- /wd4800 /wd4805 /wd4244)
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # if we compile for windows with clang, allow inline asm
    add_definitions(-DGEMMLOWP_ALLOW_INLINE_ASM)
  endif()
else()
  set(EXTERNAL_LIBRARIES "pthread")
endif()

# Glob header files
file(GLOB gemmlowp_private_headers "${gemmlowp_src}/fixedpoint/*.h" "${gemmlowp_src}/internal/*.h")
file(GLOB gemmlowp_public_headers "${gemmlowp_src}/meta/*.h" "${gemmlowp_src}/public/*.h" "${gemmlowp_src}/profiling/*.h")
list(APPEND gemmlowp_headers ${gemmlowp_private_headers} ${gemmlowp_public_headers})

file(GLOB eight_bit_int_gemm_headers "${gemmlowp_src}/eight_bit_int_gemm/*.h")
list(APPEND eight_bit_int_gemm_public_headers ${eight_bit_int_gemm_headers} ${gemmlowp_public_headers})
file(GLOB eight_bit_int_gemm_sources_with_no_headers "${gemmlowp_src}/eight_bit_int_gemm/*.cc")

list(APPEND eight_bit_int_gemm_sources
            ${eight_bit_int_gemm_headers}
            ${eight_bit_int_gemm_sources_with_no_headers}
            ${gemmlowp_headers})

file(GLOB gemmlowp_test_headers "${gemmlowp_src}/test/*.h")
list(APPEND gemmlowp_test_headers ${gemmlowp_headers})

file(GLOB fixedpoint_private_headers "${gemmlowp_src}/fixedpoint/*.h")
list(APPEND fixedpoint_private_headers "${gemmlowp_src}/internal/common.h")

add_library(eight_bit_int_gemm ${eight_bit_int_gemm_sources_with_no_headers})
set_target_properties(eight_bit_int_gemm PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
target_link_libraries(eight_bit_int_gemm ${EXTERNAL_LIBRARIES})

# INTERFACE target to help header include
add_library(gemmlowp INTERFACE)
target_include_directories(gemmlowp INTERFACE
    $<BUILD_INTERFACE:${gemmlowp_src}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp>)
target_link_libraries(gemmlowp INTERFACE eight_bit_int_gemm)

install(FILES ${eight_bit_int_gemm_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/eight_bit_int_gemm)
file(GLOB meta_headers "${gemmlowp_src}/meta/*.h")
install(FILES ${meta_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/meta)
file(GLOB public_headers "${gemmlowp_src}/public/*.h")
install(FILES ${public_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/public)
file(GLOB profile_headers "${gemmlowp_src}/profiling/*.h")
install(FILES ${profile_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/profiling)
file(GLOB internal_headers "${gemmlowp_src}/internal/*.h")
install(FILES ${internal_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/internal)
file(GLOB fixedpoint_headers "${gemmlowp_src}/fixedpoint/*.h")
install(FILES ${fixedpoint_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/gemmlowp/fixedpoint)

install(TARGETS gemmlowp eight_bit_int_gemm
        EXPORT  gemmlowp-config # support find_package(gemmlowp CONFIG)
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT  gemmlowp-config  # export gemmlowp::gemmlowp
        NAMESPACE gemmlowp::     #        gemmlowp::eight_bit_int_gemm
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/gemmlowp)

if(BUILD_TESTING)
    # Benchmarks
    add_executable(benchmark
        "${gemmlowp_src}/test/benchmark.cc" ${gemmlowp_test_headers})
    target_link_libraries(benchmark ${EXTERNAL_LIBRARIES})
    
    add_executable(benchmark_all_sizes
        "${gemmlowp_src}/test/benchmark_all_sizes.cc" ${gemmlowp_test_headers})
    target_compile_options(benchmark_all_sizes PRIVATE -DBENCHMARK_8bit -DBENCHMARK_QUICK)
    target_link_libraries(benchmark_all_sizes ${EXTERNAL_LIBRARIES})
    
    # Gemmlowp test
    add_executable(test_gemmlowp
        "${gemmlowp_src}/test/test.cc" "${gemmlowp_src}/test/test_data.cc" ${gemmlowp_test_headers})
    target_link_libraries(test_gemmlowp eight_bit_int_gemm)
    
    # Math helpers test
    add_executable(test_math_helpers
        "${gemmlowp_src}/test/test_math_helpers.cc" ${gemmlowp_test_headers})
    
    # BlockingCounter test
    add_executable(test_blocking_counter
        "${gemmlowp_src}/test/test_blocking_counter.cc" ${gemmlowp_test_headers})
    target_link_libraries(test_blocking_counter ${EXTERNAL_LIBRARIES})
    
    # Allocator test
    add_executable(test_allocator
        "${gemmlowp_src}/test/test_allocator.cc" ${gemmlowp_test_headers})
    
    # FixedPoint test
    add_executable(test_fixedpoint
        "${gemmlowp_src}/test/test_fixedpoint.cc" ${gemmlowp_test_headers})
    
    # Add tests
    enable_testing()
    foreach(testname "test_math_helpers" "test_blocking_counter" "test_allocator" "test_fixedpoint" "test_gemmlowp")
        add_test(NAME ${testname} COMMAND "${testname}")
    endforeach(testname)
endif()

## gemmlowp 0.0~git20180416.38ebac7

=== debian/changelog ===
gemmlowp (0.0~git20180416.38ebac7-1) unstable; urgency=medium

  * New upstream version 0.0~git20180416.38ebac7
  * Add watch file to monitor upstream git HEAD.
  * Bump Standards-Version to 4.1.4 (no change).
  * Move from devel section to libdevel section.
  * Remove unused override debian-watch-file-is-missing.
  * Remove debian/CMakeLists.txt because merged by upstream.
  * patches: Patch the cmake build to avoid failure.
  * Fix doc installation path and remove unused dirs. (Closes: #900474)
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 02 Jun 2018 08:17:17 +0000

gemmlowp (0~20180308-gf59a96b-1) experimental; urgency=medium

  * Initial release. (Closes: #848882)

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 26 Mar 2018 03:50:14 +0000

=== debian/control ===
Source: gemmlowp
Section: science
Priority: optional
Maintainer: Mo Zhou <cdluminate@gmail.com>
Build-Depends: debhelper (>= 11~),
               cmake,
Standards-Version: 4.1.4
Homepage: https://github.com/google/gemmlowp
Vcs-Browser: https://salsa.debian.org/lumin-guest/gemmlowp
Vcs-Git: https://salsa.debian.org/lumin-guest/gemmlowp.git

Package: libgemmlowp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
#         ${shlibs:Depends}, # there is no binary file in this package.
Description: small self-contained low-precision GEMM library
 This is not a full linear algebra library, only a GEMM library: it only does
 general matrix multiplication ("GEMM").
 .
 Its performance goals differ from typical GEMM performance goals in the
 following ways:
 1. It cares not only about speed, but also about minimizing power usage.
    It specifically cares about charge usage in mobile/embedded devices.
 2. Most GEMMs are optimized primarily for large dense matrix sizes (>= 1000).
    It does care about large sizes, but it also cares specifically about the
    typically smaller matrix sizes encountered in various mobile applications.
 .
 Keep in mind (previous section) that gemmlowp itself is a pure-headers-only
 library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	ln -s contrib/CMakeLists.txt .
	dh_auto_configure -- \
		-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)"

override_dh_installdocs:
	-mkdir -p debian/libgemmlowp-dev/usr/share/doc/libgemmlowp-dev/meta/
	install meta/README debian/libgemmlowp-dev/usr/share/doc/libgemmlowp-dev/meta/
	dh_installdocs

override_dh_auto_clean:
	-$(RM) CMakeLists.txt
	dh_auto_clean

## gemmlowp 0.0~git20180912.7c5f9be

=== debian/changelog ===
gemmlowp (0.0~git20180912.7c5f9be-1) unstable; urgency=medium

  * New upstream version 0.0~git20180912.7c5f9be
  * Transfer packaging repo to Salsa/Science-team.
  * Set Science Team as Maintainer, while myself as Uploader.
  * Bump Standards-Version to 4.2.1 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 14 Sep 2018 06:53:57 +0000

gemmlowp (0.0~git20180822.dea287e-1) unstable; urgency=medium

  * New upstream snapshot 0.0~git20180822.dea287e
  * Bump Standards-Version to 4.2.0 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 26 Aug 2018 12:49:42 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: gemmlowp
 Section: science
 Priority: optional
-Maintainer: Mo Zhou <cdluminate@gmail.com>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: debhelper (>= 11~),
                cmake,
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://github.com/google/gemmlowp
-Vcs-Browser: https://salsa.debian.org/lumin-guest/gemmlowp
-Vcs-Git: https://salsa.debian.org/lumin-guest/gemmlowp.git
+Vcs-Browser: https://salsa.debian.org/science-team/gemmlowp
+Vcs-Git: https://salsa.debian.org/science-team/gemmlowp.git
 
 Package: libgemmlowp-dev
 Section: libdevel

## gemmlowp 0.0~git20181112.18e4cc0

=== debian/changelog ===
gemmlowp (0.0~git20181112.18e4cc0-1) unstable; urgency=medium

  * New upstream version 0.0~git20181112.18e4cc0
  * Change Multi-Arch to foreign for the header only -dev package.
  * Remove README.source, not useful anymore.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 25 Nov 2018 01:51:47 +0000

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Package: libgemmlowp-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
+Multi-Arch: foreign
 Depends: ${misc:Depends},
 #         ${shlibs:Depends}, # there is no binary file in this package.
 Description: small self-contained low-precision GEMM library

## gemmlowp 0.0~git20190110.2233f5e

=== debian/changelog ===
gemmlowp (0.0~git20190110.2233f5e-1) unstable; urgency=medium

  * New upstream version 0.0~git20190110.2233f5e
  * Bump debhelper compat to 12.
  * Bump Standards-Version to 4.3.0 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 12 Jan 2019 05:41:03 +0000

## gemmlowp 0.0~git20190128.58825b1

=== debian/changelog ===
gemmlowp (0.0~git20190128.58825b1-1) unstable; urgency=medium

  * New upstream version 0.0~git20190128.58825b1

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 24 Feb 2019 02:24:17 +0000

## gemmlowp 0.0~git20190708.a227af1

=== debian/changelog ===
gemmlowp (0.0~git20190708.a227af1-1) unstable; urgency=medium

  * New upstream version 0.0~git20190708.a227af1

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 13 Aug 2019 01:57:58 +0000

## gemmlowp 0.0~git20191206.08c5dd3

=== debian/changelog ===
gemmlowp (0.0~git20191206.08c5dd3-1) unstable; urgency=medium

  * New upstream version 0.0~git20191206.08c5dd3

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 26 Dec 2019 15:12:48 +0800

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <cdluminate@gmail.com>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper (>= 12~),
                cmake,
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/google/gemmlowp
 Vcs-Browser: https://salsa.debian.org/science-team/gemmlowp
 Vcs-Git: https://salsa.debian.org/science-team/gemmlowp.git

## gemmlowp 0.0~git20200506.fda83bd

=== debian/changelog ===
gemmlowp (0.0~git20200506.fda83bd-1) unstable; urgency=medium

  * New upstream version 0.0~git20200506.fda83bd
  * Update my own mail address in control and copyright.
  * Bump Standards-Version to 4.5.0 (no change).
  * Deprecate d/compat in favor of debhelper-compat (= 13).

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Sep 2020 11:07:40 +0800

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@ -Scmake
 
 override_dh_auto_configure:
 	ln -s contrib/CMakeLists.txt .

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/google/gemmlowp \
HEAD debian uupdate

## gemmlowp 0.0~git20211220.e844ffd

=== debian/changelog ===
gemmlowp (0.0~git20211220.e844ffd-1) unstable; urgency=medium

  * New upstream version 0.0~git20211220.e844ffd

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:56:13 -0700

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: science
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Mo Zhou <cdluminate@gmail.com>
-Build-Depends: debhelper (>= 12~),
+Uploaders: Mo Zhou <lumin@debian.org>
+Build-Depends: debhelper-compat (= 13),
                cmake,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/gemmlowp
 Vcs-Browser: https://salsa.debian.org/science-team/gemmlowp
 Vcs-Git: https://salsa.debian.org/science-team/gemmlowp.git
